// C BASIC Polygon

#include <stdio.h>
#include <math.h>
#include <SDL.h>
#include "libbbc5.h"
#include "cbasic.h"

#define PI 3.14159265358979323846

MAIN
BEGIN_FUNCTION
  DIM AS float64 angle, radius, x[10], y[10];
  DIM AS int32 c, t, d, side, sides, xorigin, yorigin, i, l;
  DIM AS Uint32 t1, t2, t3;
  DIM AS char strbuff[15];
  BBC_OPEN();
  BBC_MODE(32);
  t1 = SDL_GetTicks();
  SDL_WM_SetCaption("C BASIC BBC5 - polygon", 0);
  BBC_VDU(26);
  DEF_FOR (i = 1 TO i <= 1000 STEP INCR i)
  BEGIN_FOR
    xorigin = BBC_RND(1250);
    yorigin = BBC_RND(840);
    radius = BBC_RND(300) + 50;
    BBC_ORIGIN(xorigin, yorigin);
    sides = BBC_RND(8) + 2;
    BBC_MOVE(radius, 0);
    BBC_MOVE(10, 10);
    c = BBC_RND(64) - 1;
    t = BBC_SHIFT(BBC_RND(4) - 1, 6, 0);
    BBC_GCOL(0, c, t);
    DEF_FOR (side = 1 TO side <= sides STEP INCR side)
    BEGIN_FOR
      angle = (side -1) * 2 * PI / sides;
      x[side] = radius * cos(angle);
      y[side] = radius * sin(angle);
      BBC_MOVE(0, 0);
      BBC_PLOT(85, x[side], y[side]);
    NEXT
    BBC_MOVE(0, 0);
    BBC_PLOT(85, radius, 0);
    DO
      d = BBC_RND(64) - 1;
    WHILE ((d & 63) != (c & 6));
    BBC_GCOL(0, d, t);
    DEF_FOR (side = 1 TO side <= sides STEP INCR side)
    BEGIN_FOR
      DEF_FOR (l = side TO l <= sides STEP INCR l)
      BEGIN_FOR
        BBC_MOVE(x[side], y[side]);
        BBC_DRAW(x[l], y[l]);
      NEXT
    NEXT
  NEXT
  t2 = SDL_GetTicks();
  t3 = (t2 - t1) / 1000;
  sprintf(strbuff, "%d.4 Seconds.", t3);
  BBC_OFF();
  BBC_VDUSTR(strbuff, 0);
  DEF_WHILE (BBC_GETKEY() != SDLK_ESCAPE)
   BEGIN_WHILE
  WEND
//  BBC_WAITKEY();
  BBC_CLOSE();
  RETURN_FUNCTION(0);
END_FUNCTION